import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Eldirin.Common.Utils.Utils";
import "Eldirin.LootFilter.OptionsWindow"

LoadSettings();

optionsWindow = Eldirin.LootFilter.OptionsWindow();
ShowMessage=class(Turbine.UI.Lotro.Window)

openLootWindows = {}

function ShowMessage:Constructor(message)
	x=Turbine.UI.Display:GetWidth()/2-100;
	y=Turbine.UI.Display:GetHeight()/2-100;

	Turbine.UI.Lotro.Window.Constructor(self);
	self.SetPosition=function(sender, left, top)
	Turbine.UI.Window.SetPosition(self, left, top);
	end
	self:SetSize(500,100); 
	self:SetPosition(x,y);
	self:SetText("Loot Info"); 
	self.Message=Turbine.UI.Label(); 
	self.Message:SetParent(self);
	self.Message:SetSize(440,40); 
	self.Message:SetPosition(30,40); 
	self.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.Message:SetText(message); 
	self:SetVisible(true); 


	-- removing Window from table when closed
	self.Closed = function(sender, args)
		for i = 1, table.getn(openLootWindows) do
			if openLootWindows[i] == self then
				return table.remove(openLootWindows, i)
			end
		end
	end

end

function chatHandler(sender, args)
	-- ChatTyp 36 = id for player Loot
	-- ChatTyp 37 = id for fellow loot 
	-- somehow Turbine.ChatType.FellowshipLoot and Turbine.ChatType.PlayerLoot enumerations dont work
	if args.ChatType == 36 or args.ChatType == 37 then
		-- Check if drop is blacklisted and quit function if it is
		for i = 1, table.getn(blacklist) do
			if string.match(string.lower(args.Message), string.lower(blacklist[i])) then
				return;
			end
		end
		-- Item is not blacklisted
		-- look for match in trigger list
		for i = 1, table.getn(trigger) do
			if string.match(string.lower(args.Message), string.lower(trigger[i])) then
				count = table.getn(openLootWindows) + 1;
				openLootWindows[count] = ShowMessage(args.Message);
				return;
			end
		end
	end	
end										

lootFilterCommand = Turbine.ShellCommand();

function lootFilterCommand:Execute(cmd, args)
	if ( args == "triggers" or args == "options" or args == "blacklist" ) then
		optionsWindow:SetVisible(true);
	end
end

Turbine.Shell.AddCommand( "LootFilter", lootFilterCommand );
AddCallback(Turbine.Chat, "Received", chatHandler);
Plugins["LootFilter"].Unload = function(self,sender,args)
    UnloadMe();
end

function UnloadMe()
 -- release any event handlers, callbacks, commands
 -- save any data that needs saving
	openLootWindows = {};
	SaveSettings();
end

